Wt: Wt::WAnchor Class Reference

Wt 4.10.4

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | List of all members
Wt::WAnchor Class Reference

A widget that represents an HTML anchor (to link to other documents). More...

`#include <Wt/WAnchor.h>`

Inheritance diagram for Wt::WAnchor:
[legend]

## Public Member Functions
| WAnchor ()
| Creates an anchor.
| WAnchor (const WLink &link)
| Creates an anchor for the given link.
| WAnchor (const WLink &link, const WString &text)
| Creates an anchor for the given link with a text.
| WAnchor (const WLink &link, std::unique_ptr< WImage > image)
| Creates an anchor for the given link with an image.
void | setLink (const WLink &link)
| Sets the link.
const WLink & | link () const
| Returns the link.
void | setText (const WString &text)
| Sets the label text.
const WString & | text () const
| Returns the label text.
void | setWordWrap (bool wordWrap)
| Configures text word wrapping.
void | setTextFormat (TextFormat format)
| Configures the text format.
TextFormat | textFormat () const
| Returns the text format.
bool | wordWrap () const
| Returns whether the widget may break lines.
void | setImage (std::unique_ptr< WImage > image)
| Sets an image.
WImage * | image () const
| Returns the image.
virtual bool | canReceiveFocus () const override
| Returns whether the widget can receive focus.
virtual int | tabIndex () const override
| Returns the tab index.
virtual bool | setFirstFocus () override
| Set focus on the widget's first descendant.
Public Member Functions inherited from Wt::WContainerWidget
| WContainerWidget ()
| Creates a container.
| ~WContainerWidget ()
| Destructor.
void | setLayout (std::unique_ptr< WLayout > layout)
| Sets a layout manager for the container.
template<typename Layout >
Layout * | setLayout (std::unique_ptr< Layout > layout)
| Sets a layout manager for the container, returning a raw pointer.
WLayout * | layout () const
| Returns the layout manager that was set for the container.
virtual void | addWidget (std::unique_ptr< WWidget > widget)
| Adds a child widget to this container.
template<typename Widget >
Widget * | addWidget (std::unique_ptr< Widget > widget)
| Adds a child widget to this container, returning a raw pointer.
template<typename Widget , typename ... Args>
Widget * | addNew (Args &&...args)
| Creates a widget and adds it, returning a reference to it.
virtual void | insertBefore (std::unique_ptr< WWidget > widget, WWidget *before)
| Inserts a child widget in this container, before another widget.
template<typename Widget >
Widget * | insertBefore (std::unique_ptr< Widget > widget, WWidget *before)
| Inserts a child widget to this container, before another widget, returning a raw pointer.
virtual void | insertWidget (int index, std::unique_ptr< WWidget > widget)
| Inserts a child widget in this container at given index.
template<typename Widget >
Widget * | insertWidget (int index, std::unique_ptr< Widget > widget)
| Inserts a child widget to this container at given index, returning a raw pointer.
template<typename Widget , typename ... Args>
Widget * | insertNew (int index, Args &&...args)
| Creates a widget and inserts it, returning a reference to it.
virtual std::unique_ptr< WWidget > | removeWidget (WWidget *widget) override
| Removes a child widget from this container.
virtual void | clear ()
| Removes all widgets.
virtual int | indexOf (WWidget *widget) const
| Returns the index of a widget.
virtual WWidget * | widget (int index) const
| Returns the widget at index
virtual int | count () const
| Returns the number of widgets in this container.
void | setContentAlignment (WFlags< AlignmentFlag > contentAlignment)
| Specifies how child widgets must be aligned within the container.
void | setPadding (const WLength &padding, WFlags< Side > sides=AllSides)
| Sets padding inside the widget.
WLength | padding (Side side) const
| Returns the padding set for the widget.
WFlags< AlignmentFlag > | contentAlignment () const
| Returns the alignment of children.
void | setOverflow (Overflow overflow, WFlags< Orientation > orientation=(Orientation::Horizontal|Orientation::Vertical))
| Sets how overflow of contained children must be handled.
void | setList (bool list, bool ordered=false)
| Renders the container as an HTML list.
bool | isList () const
| Returns if this container is rendered as a List.
bool | isUnorderedList () const
| Returns if this container is rendered as an Unordered List.
bool | isOrderedList () const
| Returns if this container is rendered as an Ordered List.
EventSignal< WScrollEvent > & | scrolled ()
| Event signal emitted when scrolling in the widget.
int | scrollTop () const
| return the number of pixels the container is scrolled horizontally
int | scrollLeft () const
| return the number of pixels the container is scrolled vertically
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
Public Member Functions inherited from Wt::WInteractWidget
| WInteractWidget ()
| Create an InteractWidget.
EventSignal< WKeyEvent > & | keyWentDown ()
| Event signal emitted when a keyboard key is pushed down.
EventSignal< WKeyEvent > & | keyPressed ()
| Event signal emitted when a "character" was entered.
EventSignal< WKeyEvent > & | keyWentUp ()
| Event signal emitted when a keyboard key is released.
EventSignal & | enterPressed ()
| Event signal emitted when enter was pressed.
EventSignal & | escapePressed ()
| Event signal emitted when escape was pressed.
EventSignal< WMouseEvent > & | clicked ()
| Event signal emitted when the primary mouse button was clicked on this widget.
EventSignal< WMouseEvent > & | doubleClicked ()
| Event signal emitted when the primary mouse button was double clicked on this widget.
EventSignal< WMouseEvent > & | mouseWentDown ()
| Event signal emitted when a mouse button was pushed down on this widget.
EventSignal< WMouseEvent > & | mouseWentUp ()
| Event signal emitted when a mouse button was released on this widget.
EventSignal< WMouseEvent > & | mouseWentOut ()
| Event signal emitted when the mouse went out of this widget.
EventSignal< WMouseEvent > & | mouseWentOver ()
| Event signal emitted when the mouse entered this widget.
EventSignal< WMouseEvent > & | mouseMoved ()
| Event signal emitted when the mouse moved over this widget.
EventSignal< WMouseEvent > & | mouseDragged ()
| Event signal emitted when the mouse is dragged over this widget.
EventSignal< WMouseEvent > & | mouseWheel ()
| Event signal emitted when the mouse scroll wheel was used.
EventSignal< WTouchEvent > & | touchStarted ()
| Event signal emitted when a finger is placed on the screen.
EventSignal< WTouchEvent > & | touchEnded ()
| Event signal emitted when a finger is removed from the screen.
EventSignal< WTouchEvent > & | touchMoved ()
| Event signal emitted when a finger, which is already placed on the screen, is moved across the screen.
EventSignal< WGestureEvent > & | gestureStarted ()
| Event signal emitted when a gesture is started.
EventSignal< WGestureEvent > & | gestureChanged ()
| Event signal emitted when a gesture is changed.
EventSignal< WGestureEvent > & | gestureEnded ()
| Event signal emitted when a gesture is ended.
void | setDraggable (const std::string &mimeType, WWidget *dragWidget=nullptr, bool isDragWidgetOnly=false, WObject *sourceWidget=nullptr)
| Configure dragging for drag and drop.
void | unsetDraggable ()
| Disable drag & drop for this widget.
void | setMouseOverDelay (int delay)
| Sets a delay for the mouse over event.
int | mouseOverDelay () const
| Returns the mouse over signal delay.
virtual void | setPopup (bool popup) override
| Lets the widget overlay over other sibling widgets.
virtual void | load () override
| Loads content just before the widget is used.
virtual bool | isEnabled () const override
| Returns whether the widget is enabled.
Public Member Functions inherited from Wt::WWebWidget
| WWebWidget ()
| Construct a WebWidget.
virtual std::vector< WWidget * > | children () const override
| Returns child widgets.
Signal & | childrenChanged ()
| Signal emitted when children have been added or removed.
virtual void | setPositionScheme (PositionScheme scheme) override
| Sets the CSS position scheme.
virtual PositionScheme | positionScheme () const override
| Returns the CSS position scheme.
virtual void | setOffsets (const WLength &offset, WFlags< Side > sides=AllSides) override
| Sets CSS offsets for a non-statically positioned widget.
virtual WLength | offset (Side s) const override
| Returns a CSS offset.
virtual void | resize (const WLength &width, const WLength &height) override
| Resizes the widget.
virtual WLength | width () const override
| Returns the width.
virtual WLength | height () const override
| Returns the height.
virtual void | setMinimumSize (const WLength &width, const WLength &height) override
| Sets a minimum size.
virtual WLength | minimumWidth () const override
| Returns the minimum width.
virtual WLength | minimumHeight () const override
| Returns the minimum height.
virtual void | setMaximumSize (const WLength &width, const WLength &height) override
| Sets a maximum size.
virtual WLength | maximumWidth () const override
| Returns the maximum width.
virtual WLength | maximumHeight () const override
| Returns the maximum height.
virtual void | setLineHeight (const WLength &height) override
| Sets the CSS line height for contained text.
virtual WLength | lineHeight () const override
| Returns the CSS line height for contained text.
virtual void | setFloatSide (Side s) override
| Specifies a CSS float side.
virtual Side | floatSide () const override
| Returns the CSS float side.
virtual void | setClearSides (WFlags< Side > sides) override
| Sets the sides that should be cleared of floats.
virtual WFlags< Side > | clearSides () const override
| Returns the sides that should remain empty.
virtual void | setMargin (const WLength &margin, WFlags< Side > sides=AllSides) override
| Sets CSS margins around the widget.
virtual WLength | margin (Side side) const override
| Returns a CSS margin set.
virtual void | setHiddenKeepsGeometry (bool enabled) override
| Sets whether the widget keeps its geometry when hidden.
virtual bool | hiddenKeepsGeometry () const override
| Returns whether the widget keeps its geometry when hidden.
virtual void | setHidden (bool hidden, const WAnimation &animation=WAnimation()) override
| Hides or shows the widget.
virtual bool | isHidden () const override
| Returns whether the widget is set hidden.
virtual bool | isVisible () const override
| Returns whether the widget is visible.
virtual void | setDisabled (bool disabled) override
| Sets whether the widget is disabled.
virtual bool | isDisabled () const override
| Returns whether the widget is set disabled.
virtual bool | isPopup () const override
| Returns whether the widget is overlayed.
virtual void | setInline (bool isInline) override
| Sets whether the widget is displayed inline or as a block.
virtual bool | isInline () const override
| Returns whether the widget is displayed inline or as block.
virtual void | setDecorationStyle (const WCssDecorationStyle &style) override
| Sets a CSS decoration style.
virtual WCssDecorationStyle & | decorationStyle () override
| Returns the decoration style of this widget.
virtual void | setStyleClass (const WString &styleClass) override
| Sets (one or more) CSS style classes.
virtual WString | styleClass () const override
| Returns the CSS style class.
virtual void | addStyleClass (const WString &styleClass, bool force=false) override
| Adds a CSS style class.
virtual void | removeStyleClass (const WString &styleClass, bool force=false) override
| Removes a CSS style class.
virtual bool | hasStyleClass (const WString &styleClass) const override
| Returns whether the widget has a style class.
virtual void | setVerticalAlignment (AlignmentFlag alignment, const WLength &length=WLength()) override
| Sets the vertical alignment.
virtual AlignmentFlag | verticalAlignment () const override
| Returns the vertical alignment.
virtual WLength | verticalAlignmentLength () const override
| Returns the fixed vertical alignment that was set.
virtual void | setToolTip (const WString &text, TextFormat textFormat=TextFormat::Plain) override
| Sets a tooltip.
virtual void | setDeferredToolTip (bool enable, TextFormat textFormat=TextFormat::Plain) override
| Enable deferred tooltip.
virtual WString | toolTip () const override
| Returns the tooltip.
virtual void | refresh () override
| Refresh the widget.
virtual void | setAttributeValue (const std::string &name, const WString &value) override
| Sets an attribute value.
virtual WString | attributeValue (const std::string &name) const override
| Returns an attribute value.
virtual void | setJavaScriptMember (const std::string &name, const std::string &value) override
| Sets a JavaScript member.
virtual std::string | javaScriptMember (const std::string &name) const override
| Returns the value of a JavaScript member.
virtual void | callJavaScriptMember (const std::string &name, const std::string &args) override
| Calls a JavaScript member.
virtual bool | loaded () const override
| Returns whether this widget has been loaded.
virtual void | setId (const std::string &id) override
| Sets the CSS Id.
virtual WWidget * | find (const std::string &name) override
| Finds a descendent widget by name.
virtual WWidget * | findById (const std::string &id) override
| Finds a descendent widget by id.
virtual void | setSelectable (bool selectable) override
| Sets as selectable.
virtual void | doJavaScript (const std::string &javascript) override
| Executes the given JavaScript statements when the widget is rendered or updated.
virtual const std::string | id () const override
| Returns the (unique) identifier for this object.
void | setLoadLaterWhenInvisible (bool)
| Change the way the widget is loaded when invisible.
std::string | htmlTagName () const
| returns the current html tag name
void | setHtmlTagName (const std::string &tag)
| set the custom HTML tag name
virtual void | setCanReceiveFocus (bool enabled) override
| Sets whether the widget can receive focus.
virtual void | setFocus (bool focus) override
| Sets focus.
virtual bool | hasFocus () const override
| Returns whether the widget currently has the focus.
virtual void | setTabIndex (int index) override
| Sets the tab index.
EventSignal & | blurred ()
| Signal emitted when the widget lost focus.
EventSignal & | focussed ()
| Signal emitted when the widget recieved focus.
virtual bool | scrollVisibilityEnabled () const final override
| Returns whether scroll visibility detection is enabled for this widget.
virtual void | setScrollVisibilityEnabled (bool enabled) final override
| Sets whether scroll visibility detection is enabled for this widget.
virtual int | scrollVisibilityMargin () const final override
| Returns the margin around the viewport within which the widget is considered visible.
virtual void | setScrollVisibilityMargin (int margin) final override
| Sets the margin around the viewport within which the widget is considered visible.
virtual Signal< bool > & | scrollVisibilityChanged () final override
| Signal triggered when the scroll visibility of this widget changes.
virtual bool | isScrollVisible () const final override
| Returns whether this widget is currently considered scroll visible.
virtual void | setThemeStyleEnabled (bool enabled) final override
| Sets whether theme styling for a widget is enabled or disabled.
virtual bool | isThemeStyleEnabled () const final override
| Returns whether this widget is currently styled by the chosen theme.
virtual void | setObjectName (const std::string &name) override
| Sets an object name.
void | setFocus ()
| Sets focus.
Public Member Functions inherited from Wt::WWidget
virtual | ~WWidget ()
| Destructor.
WWidget * | parent () const
| Returns the parent widget.
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
std::unique_ptr< WWidget > | removeFromParent ()
| Removes the widget from its parent.
void | setWidth (const WLength &width)
| Sets the width.
void | setHeight (const WLength &height)
| Sets the height.
virtual void | positionAt (const WWidget *widget, Orientation orientation=Orientation::Vertical)
| Positions a widget next to another widget.
virtual void | toggleStyleClass (const WString &styleClass, bool add, bool force=false)
| Toggles a CSS style class.
std::string | jsRef () const
| Returns a JavaScript expression to the corresponding DOM node.
void | setFocus ()
| Sets focus.
virtual void | acceptDrops (const std::string &mimeType, const WString &hoverStyleClass=WString())
| Sets a mime type to be accepted for dropping.
virtual void | stopAcceptDrops (const std::string &mimeType)
| Indicates that a mime type is no longer accepted for dropping.
virtual void | htmlText (std::ostream &out)
| Streams the (X)HTML representation.
bool | isRendered () const
| Returns whether the widget is rendered.
void | hide ()
| Hides the widget.
void | animateHide (const WAnimation &animation)
| Hides the widget using an animation.
void | show ()
| Shows the widget.
void | animateShow (const WAnimation &animation)
| Shows the widget using an animation.
void | enable ()
| Enables the widget.
void | disable ()
| Disable thes widget.
bool | layoutSizeAware () const
| Returns whether the widget is layout size aware.
Public Member Functions inherited from Wt::WObject
void | addChild (std::unique_ptr< WObject > child)
| Add a child WObject whose lifetime is determined by this WObject.
template<typename Child >
Child * | addChild (std::unique_ptr< Child > child)
| Add a child WObject, returning a raw pointer.
std::unique_ptr< WObject > | removeChild (WObject *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
template<typename Child >
std::unique_ptr< Child > | removeChild (Child *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
virtual std::string | objectName () const
| Returns the object name.
void | resetLearnedSlots ()
| Resets learned stateless slot implementations.
template<class T >
void | resetLearnedSlot (void(T::*method)())
| Resets a learned stateless slot implementation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)())
| Declares a slot to be stateless and learn client-side behaviour on first invocation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)(), void(T::*undoMethod)())
| Declares a slot to be stateless and learn client-side behaviour in advance.
void | isNotStateless ()
| Marks the current function as not stateless.
template<class T >
WStatelessSlot * | implementJavaScript (void(T::*method)(), const std::string &jsCode)
| Provides a JavaScript implementation for a method.
Public Member Functions inherited from Wt::Core::observable
| observable () noexcept
| Default constructor.
virtual | ~observable ()
| Destructor.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...)) noexcept
| Protects a method call against object destruction.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...) const) const noexcept
| Protects a const method call against object destruction.
template<typename Function >
auto | bindSafe (const Function &function) noexcept
| Protects a function against object destruction.

## Protected Member Functions
virtual void | propagateSetEnabled (bool enabled) override
| Propagates that a widget was enabled or disabled through children.
virtual void | enableAjax () override
| Progresses to an Ajax-enabled widget.
Protected Member Functions inherited from Wt::WContainerWidget
Protected Member Functions inherited from Wt::WInteractWidget
Protected Member Functions inherited from Wt::WWebWidget
virtual WStatelessSlot * | getStateless (Method method) override
| On-demand stateless slot implementation.
virtual void | render (WFlags< RenderFlag > flags) override
| Renders the widget.
Protected Member Functions inherited from Wt::WWidget
void | setLayoutSizeAware (bool sizeAware)
| Sets the widget to be aware of its size set by a layout manager.
virtual void | layoutSizeChanged (int width, int height)
| Virtual method that indicates a size change.
| WWidget ()
| Creates a widget.
virtual void | dropEvent (WDropEvent dropEvent)
| Handles a drop event.
virtual int | boxPadding (Orientation orientation) const
| Returns the widget's built-in padding.
virtual int | boxBorder (Orientation orientation) const
| Returns the widget's built-in border width.
void | scheduleRender (WFlags< RepaintFlag > flags=None)
| Schedules rerendering of the widget.
Protected Member Functions inherited from Wt::WObject

## Additional Inherited Members
Public Types inherited from Wt::WObject
typedef void(WObject::*) | Method()
| Typedef for a WObject method without arguments.
Static Public Member Functions inherited from Wt::WWebWidget
static std::string | jsStringLiteral (const std::string &v, char delimiter='\'')
| Turn a CharEncoding::UTF8 encoded string into a JavaScript string literal.
Static Public Member Functions inherited from Wt::WWidget
static WString | tr (const char *key)
| Short hand for WString::tr()
Static Public Member Functions inherited from Wt::WObject
Static Public Attributes inherited from Wt::WWidget
Protected Types inherited from Wt::WWebWidget
Protected Types inherited from Wt::WWidget
Protected Attributes inherited from Wt::WInteractWidget
Static Protected Attributes inherited from Wt::WInteractWidget
Static Protected Attributes inherited from Wt::WWidget

## Detailed Description

A widget that represents an HTML anchor (to link to other documents).

Use an anchor to link to another web page, document, internal application path or a resource (which specifies application-dependent content that may be generated by your application on demand). The anchor may contain a label text, an image, or any other widget (as it inherits from WContainerWidget).

If you link to a document or external url, and do not want the application to terminate when the user follows the anchor, you must use link.setTarget(LinkTarget::NewWindow). Even for non-HTML documents, this may be important since pending Ajax requests are cancelled if documents are not served within the browser window in certain browsers.

Usage example:

WAnchor *a;
// Create an anchor that links to a URL
a = addWidget(std::make_unique<Wt::WAnchor>("https://www.webtoolkit.eu/", "Wt web toolkit"));
// Create an anchor that links to an internal path
a = addWidget(std::make_unique<Wt::WAnchor>(
WLink(LinkType::InternalPath, "/docs/" + myDocName()), "Doc"));
// and listen to the corresponding change in internal path
WApplication::instance()->internalPathChanged().connect(this, &DocsListWidget::onInternalPathChange);
// Create an anchor that links to a resource
WResource *r = addChild(std::make_unique<PdfResource>()); // serializes to a PDF file.
a = addWidget(std::make_unique<Wt::WAnchor>(r, "PDF version"));
Wt::Signal::connect
virtual Wt::Signals::connection connect(WObject *target, WObject::Method method) override
Connects to a slot.
Definition WSignal.h:730
Wt::WAnchor
A widget that represents an HTML anchor (to link to other documents).
Definition WAnchor.h:68
Wt::WApplication::internalPathChanged
Signal< std::string > & internalPathChanged()
Signal which indicates that the user changes the internal path.
Wt::WApplication::instance
static WApplication * instance()
Returns the current application instance.
Wt::WContainerWidget::addWidget
virtual void addWidget(std::unique_ptr< WWidget > widget)
Adds a child widget to this container.
Wt::WLink
A value class that defines a hyperlink target.
Definition WLink.h:35
Wt::WObject::addChild
void addChild(std::unique_ptr< WObject > child)
Add a child WObject whose lifetime is determined by this WObject.
Wt::WResource
An object which can be rendered in the HTTP protocol.
Definition WResource.h:178
Wt::LinkType::InternalPath
@ InternalPath
An internal path.

WAnchor is an inline widget.

### CSS

The widget corresponds to the HTML `<a>` tag and does not provide styling. It can be styled using inline or external CSS as appropriate.

## Constructor & Destructor Documentation

## ◆ WAnchor() [1/3]

Wt::WAnchor::WAnchor | ( | const WLink & | link | ) |

Creates an anchor for the given link.

The `link` may point to a URL, a dynamic resource, or an internal path.

See also
  setLink()

## ◆ WAnchor() [2/3]

Wt::WAnchor::WAnchor | ( | const WLink & | link,
|  | const WString & | text )

Creates an anchor for the given link with a text.

The `link` may point to a URL, a dynamic resource, or an internal path.

See also
  setLink(), setText()

## ◆ WAnchor() [3/3]

Wt::WAnchor::WAnchor | ( | const WLink & | link,
|  | std::unique_ptr< WImage > | image )

Creates an anchor for the given link with an image.

Ownership of the image is transferred to the anchor.

See also
  setLink(), setImage()

## Member Function Documentation

## ◆ canReceiveFocus()

virtual bool Wt::WAnchor::canReceiveFocus | ( |  | ) | const
| overridevirtual

Returns whether the widget can receive focus.

See also
  setCanReceiveFocus()

Reimplemented from Wt::WWebWidget.

## ◆ enableAjax()

virtual void Wt::WAnchor::enableAjax | ( |  | ) |
| overrideprotectedvirtual

Progresses to an Ajax-enabled widget.

This method is called when the progressive bootstrap method is used, and support for AJAX has been detected. The default behavior will upgrade the widget's event handling to use AJAX instead of full page reloads, and propagate the call to its children.

You may want to reimplement this method if you want to make changes to widget when AJAX is enabled. You should always call the base implementation.

See also
  WApplication::enableAjax()

Reimplemented from Wt::WWebWidget.

## ◆ image()

WImage * Wt::WAnchor::image | ( |  | ) | const

Returns the image.

Returns `0` if no image is set.

See also
  setImage()

## ◆ link()

const WLink & Wt::WAnchor::link | ( |  | ) | const

Returns the link.

See also
  setLink()

## ◆ propagateSetEnabled()

virtual void Wt::WAnchor::propagateSetEnabled | ( | bool | enabled | ) |
| overrideprotectedvirtual

Propagates that a widget was enabled or disabled through children.

When enabling or disabling a widget, you usually also want to disable contained children. This method is called by setDisabled() to propagate its state to all children.

You may want to reimplement this method if they wish to render differently when a widget is disabled. The default implementation will propagate the signal to all children.

Reimplemented from Wt::WInteractWidget.

## ◆ setFirstFocus()

virtual bool Wt::WAnchor::setFirstFocus | ( |  | ) |
| overridevirtual

Set focus on the widget's first descendant.

Set focus on the widget itself, or on a first descendant which can receive focus.

Returns whether focus could be set.

Reimplemented from Wt::WWebWidget.

## ◆ setImage()

void Wt::WAnchor::setImage | ( | std::unique_ptr< WImage > | image | ) |

Sets an image.

If an image was previously set, it is deleted. The `image` is added using addWidget().

## ◆ setLink()

void Wt::WAnchor::setLink | ( | const WLink & | link | ) |

Sets the link.

The link may hold a URL, a resource, or an internal path.

When the link points to a resource, the contents of the link may be generated by your application on demand.

When the link points to an internal path, activating the anchor will change the application's internal path or open a new session with the given path as initial path). This is the easiest way to let the application participate in browser history, and generate URLs that are bookmarkable and search engine friendly.

## ◆ setText()

void Wt::WAnchor::setText | ( | const WString & | text | ) |

Sets the label text.

If no text was previously set, a new WText widget is added using addWidget().

## ◆ setTextFormat()

void Wt::WAnchor::setTextFormat | ( | TextFormat | format | ) |

Configures the text format.

The default text format is TextFormat::XHTML.

See also
  WText::setTextFormat()

## ◆ setWordWrap()

void Wt::WAnchor::setWordWrap | ( | bool | wordWrap | ) |

Configures text word wrapping.

When `wordWrap` is `true`, the text set with setText() may be broken up over multiple lines. When `wordWrap` is `false`, the text will displayed on a single line, unless the text contains `<br />` tags or other block-level tags.

The default value is `true`.

See also
  wordWrap()

## ◆ tabIndex()

virtual int Wt::WAnchor::tabIndex | ( |  | ) | const
| overridevirtual

Returns the tab index.

See also
  setTabIndex()

Reimplemented from Wt::WWebWidget.

## ◆ text()

const WString & Wt::WAnchor::text | ( |  | ) | const

Returns the label text.

Returns an empty string if no label was set.

See also
  setText()

## ◆ textFormat()

TextFormat Wt::WAnchor::textFormat | ( |  | ) | const

Returns the text format.

See also
  setTextFormat()

## ◆ wordWrap()

bool Wt::WAnchor::wordWrap | ( |  | ) | const

Returns whether the widget may break lines.

See also
  setWordWrap(bool)